%define subrel  1

%define major 5.2
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d
%define staticname %mklibname %{name} -d -s
%define alt_priority %(echo %{major} | sed -e 's/[^0-9]//g')

Summary:	Powerful, light-weight programming language
Name:		lua
Version:	5.2.2
Release:	%mkrel 2
License:	MIT
Group:		Development/Other
URL:		http://www.lua.org/
Source0:	http://www.lua.org/ftp/%{name}-%{version}.tar.gz
Source1:	lua.pc
Patch0:		lua-5.2.1-dynlib.patch
# https://bugs.mageia.org/show_bug.cgi?id=14038
Patch1:		lua-5.2.2-upstream-fix-stack-overflow-CVE-2014-5461.patch
Patch2:		lua-5.2.0-modules_path.patch
Provides:	lua%{major}
BuildRequires:	libreadline-devel
BuildRequires:	ncurses-devel

%description
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

%package -n %{libname}
Summary:	Powerful, light-weight programming language
Group:		Development/Other

%description -n %{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

%package -n %{develname}
Summary:	Headers and development files for Lua
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	liblua%{major}-devel = %{version}-%{release}
Provides:	lua-devel = %{version}-%{release}
Provides:	lua%{major}-devel = %{version}-%{release}

%description -n %{develname}
This package contains the headers and development files for Lua.

%package -n	%{staticname}
Summary:	Static development files for Lua
Group:		Development/Other
Provides:	lua-devel-static = %{version}-%{release}
Provides:	lua-static-devel = %{version}-%{release}
Requires:	%{develname} = %{version}-%{release}

%description -n	%{staticname}
This package contains the static development files for Lua.

%prep
%setup -q
%patch0 -p1 -b .dynlib
%patch1 -p1 -b .CVE-2014-5461
%patch2 -p1 -b .modules
mkdir -p etc
cp %{SOURCE1} ./etc/
sed -i -e 's/@MAJOR_VERSION@/%{major}/g' ./etc/lua.pc
sed -i -e 's/@FULL_VERSION@/%{version}/g' ./etc/lua.pc

sed -i -e "s|/usr/local|%{_prefix}|g" Makefile
sed -i -e "s|/lib|/%{_lib}|g" Makefile
sed -i -e "s|/usr/local|%{_prefix}|g" src/luaconf.h
sed -i -e "s|/lib|/%{_lib}|g" src/luaconf.h
sed -i -e "s|/man/man1|/share/man/man1|g" Makefile
sed -i -e "s|\$(V)|%{major}|g" src/Makefile

%build
sed -i 's/-lncurses/-lncursesw/g' */Makefile*
%make linux CFLAGS="%{optflags} -fPIC -DLUA_USE_LINUX"

%install
rm -rf %{buildroot}

%makeinstall_std INSTALL_TOP=%{buildroot}%{_prefix} INSTALL_LIB=%{buildroot}%{_libdir} INSTALL_MAN=%{buildroot}%{_mandir}/man1
install -d %{buildroot}%{_libdir}/lua/%{major}/
install -d %{buildroot}%{_datadir}/lua/%{major}/

install -m 755 src/liblua.so.%{major}* %{buildroot}%{_libdir}
ln -s liblua.so.%{major} %{buildroot}%{_libdir}/liblua.so

install -d -m 755 %{buildroot}%{_libdir}/pkgconfig/
install -m 644 etc/lua.pc %{buildroot}%{_libdir}/pkgconfig/

# for update-alternatives
mv %{buildroot}%{_bindir}/lua %{buildroot}%{_bindir}/lua%{major}
mv %{buildroot}%{_bindir}/luac %{buildroot}%{_bindir}/luac%{major}

%clean
rm -rf %{buildroot}

%post
/usr/sbin/update-alternatives --install %{_bindir}/lua lua %{_bindir}/lua%{major} %{alt_priority} --slave %{_bindir}/luac luac %{_bindir}/luac%{major}

%postun
[[ -f %{_bindir}/lua%{major} ]] || /usr/sbin/update-alternatives --remove lua %{_bindir}/lua%{major}

%files
%defattr (-,root,root)
%doc doc/*{.html,.css,.gif,.png}
%doc README
%{_bindir}/*
%{_mandir}/man1/*

%files -n %{libname}
%defattr (-,root,root)
%{_libdir}/liblua.so.%{major}*

%files -n %{develname}
%defattr (-,root,root)
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_libdir}/liblua.so

%files -n %{staticname}
%defattr (-,root,root)
%{_libdir}/*.a



%changelog
* Sat Oct 18 2014 akien <akien> 5.2.2-2.1.mga4
+ Revision: 783972
- Upstream patch to fix CVE-2014-5461 (mga#14038)

* Sat Oct 19 2013 umeabot <umeabot> 5.2.2-2.mga4
+ Revision: 522814
- Mageia 4 Mass Rebuild

* Thu Mar 28 2013 guillomovitch <guillomovitch> 5.2.2-1.mga3
+ Revision: 405991
- new version

* Sat Jan 12 2013 umeabot <umeabot> 5.2.1-2.mga3
+ Revision: 359041
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Sep 08 2012 luigiwalser <luigiwalser> 5.2.1-1.mga3
+ Revision: 289798
- 5.2.1

  + fwang <fwang>
    - drop old taball

* Sat Jun 02 2012 blue_prawn <blue_prawn> 5.2.0-1.mga3
+ Revision: 253448
- sync tarball lua-5.2.0.tar.gz
- update to last version lua-5.2.0

* Sat Jun 02 2012 blue_prawn <blue_prawn> 5.1.4-11.mga3
+ Revision: 253361
- the .o file of the interactive interpreter should not be included in the .so lib

* Fri Mar 09 2012 tv <tv> 5.1.4-10.mga2
+ Revision: 221977
- link with libncursesw instead of libncurses else rpm is linked with
  both libncursesw & libncurses and text installer crashes (mga#4724)

* Sun Jan 09 2011 shikamaru <shikamaru> 5.1.4-9.mga1
+ Revision: 3362
- Spec cleaning
- remove old obsoletes
- remove ldconfig in post (handled in filetriggers)
- imported package lua

